outline = "main.dxf";

module pinion(a) {
  color([0, 0, 1, a]) {
	  linear_extrude(height=6, convexity=5) {
	       import(file=outline, layer="1", $fn=80);
	     }
	

	  linear_extrude(height=6+8.4, convexity=5) {
	       import(file=outline, layer="1b", $fn=32);
	     }
    }
}

module spur(a) {
  color([0, 0.7, 0, a]) {
	  linear_extrude(height=6, convexity=5) {
	       import(file=outline, layer="4", $fn=80);
	     }
	

	  linear_extrude(height=6+8.4, convexity=5) {
	       import(file=outline, layer="4b", $fn=32);
	     }
  }
}


module base(a) {
   color([0.75, 0, 0, a]) {
    difference() {
     union() {
	  linear_extrude(height=3, convexity=5) {
	       import(file=outline, layer="20", $fn=80);
	     }

     linear_extrude(height=8, convexity=5) {
       import(file=outline, layer="22", $fn=80);
     }

     }
   translate([0,0,-0.5])
	  linear_extrude(height=3, convexity=5) {
	       import(file=outline, layer="23", $fn=4);
	     }

    }
	

	  linear_extrude(height=8, convexity=5) {
	       import(file=outline, layer="21", $fn=64);
	     }
 

   }
}

module cap(a) {

    color([0.5, 0, 1, a]) {
	  linear_extrude(height=3, convexity=5) {
	       import(file=outline, layer="200", $fn=80);
	     }

	  linear_extrude(height=8, convexity=5) {
	       import(file=outline, layer="201", $fn=80);
	     }

    difference() {
	  linear_extrude(height=27, convexity=5) {
	       import(file=outline, layer="30", $fn=80);
	     }
    
    translate([22,0,15])
    rotate([90,0,0])
    cylinder(r=9,h=50,$fn=32,center=true);

    translate([22,0,15])
    rotate([90,0,90])
    cylinder(r=9,h=50,$fn=32,center=true);
   }
}
}


module assembly(a) {
	base(a);

	translate([0,0,18])
	rotate([180,0,0])
	union() {
	   translate([0,0,6])
	   rotate([180,0,0])
		spur(a);
		
		rotate([0,0,(360/8)/2])
		pinion(a);

  translate([0,0,-17])
  cap(a);
  }

}

module plate() {
  base(1);
  translate([-40, 40, 0])
  spur(1);
  pinion(1);
  translate([0, 45, 0])
  cap(1);

}

// try one!
assembly(1);
//plate();
//cap(1);
//base(1);
